
# HUMAnN2 History #

## v0.7.1 04-27-2016 ##

### New Features ###

* A new option, "--search-mode <uniref50/uniref90>", was added. The default is set based on the translated database selected. This option sets the percent identity, chocophlan annotation index, and the translated search parameters.
* A new tool, humann2_gene_families_genus_level, and tutorial were added to create genus level gene families and pathways files.
* A new tool was added, humann2_split_stratified_table, to split output files into stratified and unstratified tables.

## v0.7.0 03-22-2016 ##

### New Features ###

* A new translated search filtering feature has been added. This by default filters alignments with less than 90% query coverage. This option is named "--translated-query-coverage-threshold <90.0>". The previous coverage option "--coverage-threshold <40.0>" has been renamed to "--translated-subject-coverage-threshold <50.0>" for clarity with the default increased from 40% to 50%. 
* New options have been added to the humann2_rename_table script. An option to switch between community and levelwise normalization was added with the default set to community normalization. Special features like UNMAPPED categories can now be excluded when normalizing. Also the flag "--norm" has been renamed "--units" to clarify this option only changes the units reported not the style of normalization.
* Four new translated search diamond formatted databases are now available. Two of the databases contain the full set of protein sequences (one for UniRef50 and one for UniRef90). The other databases are filtered to only include those proteins with ECs of level 4 or that are included in a MetaCyc pathway. The full databases allow users to identify unclassified proteins in their data set while the filtered databases require less memory and run time.

## v0.6.2 02-24-2016 ##

### New Features ###

* HUMAnN2 is now pip installable. The documentation has been updated to reflect this new feature.
* New options were added, to add names to kegg pathways and modules, to the humann2_rename_table script.
* A new tool was added to build a custom diamond database with taxonomic limitation. Adding this tool expands the Kegg legacy flow tutorial to start with quality controlled metagenome files and to include MetaPhlAn2 output.

## v0.6.1 02-10-2016 ##

### New Features ###

* The UniRef50_unknown and UniRef90_unknown values are now included in the gene families file.
    * For information on these values, please see the documentation section on the gene families file.
* More functional tests have been added
    * 12 functional end-to-end humann2 tests were added which run in about 19 minutes
    * 21 functional tool tests were added
* The tool humann2_join_tables now has the option to search sub-directories of the input folder for files to join.

### Bug Fixes ###

* If "--remove-stratified-output" is selected, the stratified output for the UNINTEGRATED pathways values are no longer printed
* The name of the UniRef50 to RXN mapping file, for script humann2_regroup_table, was updated
    * This resolves the error seen when running humann2_regroup_table with option "--groups uniref50_rxn"
* The step to build the fasta file for the custom ChocoPhlAn database has been split into multiple steps
    * This resolves the max arguments error seen when running on a MacOS with "--bypass-prescreen"

## v0.6.0 01-15-2016 ##

### New Features ###

* To reduce the influence of spurious hits in the translated search step, raw translated search results are now subjected to an initial protein coverage filter (default >50%). A read's weight is only divided over proteins that meet this coverage threshold, which (in addition to removing spurious hits) has the added benefit of substantially reducing the size of the genefamilies.tsv output file. To change the default coverage threshold, use the option "--coverage-threshold <50.0>".
* Unmapped reads are now included in the gene families abundance output file as a new "UNMAPPED" feature. This value represents the total unmapped reads after both searches, nucleotide and translated. For more information on this computation, see the documentation section about the gene families abundance file. 
* Unmapped read abundance is similarly carried through to the pathway abundance file, along with a new stratified feature, "UNINTEGRATED," which reflects the total abundance of genes that did not contribute to a metabolic pathway. These features are included in the pathway coverage file to maintain pathway abundance/coverage concordance (see below). For information on how these values are calculated, see the documentation section for each file. 

### Other Changes ###

* The included mapping from level-4 EC groups to UniRef50 clusters has been expanded based on annotations from TrEMBL. ~10x more UniRef50s can now be mapped to a level-4 EC group.
* The regroup_table script has been modified to include an "UNGROUPED" group, which captures the abundance of features that failed to map to another, non-trivial group. The "UNMAPPED" feature (see above) will always carry through to a regrouped table.
* The format of the pathway abundance and coverage output files has been updated so both files include the same order of pathways and species. The pathways are ordered by decreasing abundance. Pathways with zero abundance are not included.

## v0.5.0 10-22-2015 ##

### New Features ###

* Added default read length alignment normalization
    * This replaces the optional read length normalization using "--average-read-length L"
* Added new script humann2_merge_abundance_tables
    * This script merges the tables to stratify gene families with respect to pathways

### Other Changes ###

* Updated gap fill method to fill single lowest score
* Join script updated to allow for input files containing multiple samples
* Required Diamond version updated to v0.7.9+

## v0.4.0 09-16-2015 ##

### New Features ###

* Improvements to MetaCyc pathway quantification
    * Refined gene families to MetaCyc reactions mapping (update ignores ECs with less than 4 levels of classification)

### Cross Platform Compatibility Updates ###

* Modification to glpk/glpsol update version (resolves glpsol write permission errors and glpsol links to build directory)

## v0.3.1 08-24-2015 ##

### Cross Platform Compatibility Updates ###

* Added new option "--build-diamond" to the install (the default for Mac OS is to build diamond)

### Bug Fixes ###

* Updated the fastq to fasta function to allow for quality score lines that are similar to sequence lines (ie all alphabetical characters)

## v0.3.0 08-20-2015 ##

### New Features ###

* Improvements to structured pathway quantification identify more pathways
    * Updated databases to MetaCyc v19.1
    * Added UniProt TrEMBL data to reactions mappings
    * Added gap filling
* Added automated install of dependencies (bowtie2 and diamond)
* Added alert for user when running with demo databases and non-demo input file
* Added new option "--names {ko,metacyc-pwy,uniref50}" to humann2_rename_table
* Added new option "--groups {uniref50_ko,uniref50_go,uniref50_ec,uniref50_rxn}" to humann2_regroup_table
* Added new option "--output-max-decimals" to set the number of decimals written to the output files

### Interface Changes ###

* The default mapping file format for humann2_regroup_table has been reversed (it is now groups to features)
* The humann2_rename_table option for a custom mapping file was changed from "--names" to "--custom"
* The humann2_regroup_table option for a custom mapping file was changed from "--groups" to "--custom" 

### Bug Fixes ###

* Updated fastq to fasta function to allow for "@" (special fastq character) at beginning of quality score lines

### Cross Platform Compatibility Updates ###

* Updated humann2_join_table to ignore dot files (ie .DS_Store on Apple OS X)

## v0.2.2 07-27-2015 ##

### Cross Platform Compatibility Updates ###

* Added to install process the setting execute permissions on glpsol binaries
    * On some platforms when glpsol is installed by setuptools it does not keep its execute permissions

## v0.2.1 07-23-2015 ##

### New Features ###

* Added "--metaphlan-options"
    * Allows user to set any options for MetaPhlAn2 including database locations
    * Example: --metaphlan-options="-t rel_ab"
* Error message reporting has been updated to include messages from external tools
    * Example: "metaphlan2.py: error: unrecognized arguments: --stat_e 1.0"
* Updated MetaCyc structured pathways database
    * Removed reactions with only non-specific ECs
    * Set unmappable reactions (those without links to gene families) as optional reactions
    * Filtered out small pathways

### Interface Changes ###

* Changed option names to be more general for users with custom flows
    * Changed "--chocophlan" to "--nucleotide-database"
    * Changed "--uniref" to "--protein-database"

### Bug Fixes ###

* Updated function which determines file format to allow for gene tables with scientific notation

## v0.2.0 07-01-2015 ##

### New Features ###

* Added MetaCyc structured pathways database
* Added structured pathways computations for abundance and coverage

## v0.1.10 06-30-2015 ##

### New Features ###

* Added pathways and gene family names to output files
* Changed from e-value to number of matches for alignment scoring 

### Bug Fixes ###

* Allow for non-comment, empty lines in gene tables

## v0.1.9 05-01-2015 ##

### New Features ###

* Updated download script to pull new ChocoPhlAn version
* Added humann2_reduce_table script

### Performance Updates ###

* Reduced memory and increased speed for humann2_join_tables script

## v0.1.8 04-30-2015 ##

### New Features ###

* Updated pathways to UniProt 2015_05
* Allow for a directory, bowtie2 index basename, or bowtie2 index file as input

## v0.1.7 04-24-2015 ##

### Bug Fixes ###

* Updated function which finds executable in $PATH to return first instance instead of last

## v0.1.6 04-20-2015 ##

### Performance Updates ###

* Reduced memory use for humann2_split_table

### Other ###

* Added python version check to install

## v0.1.5 04-09-2015 ##

### Performance Updates ###

* Reduced memory use of humann2 (and added --memory-use option)

### New Features ###

* Allow for input files from Picrust metagenome_contributions.py

