---
title: "humann2 hutlab MetaCyc, UniProtKB/Swissprot and UniProtKB/TrEMBL reference databases "
author: "George_Weingart"
date: " August 25, 2015"
output: pdf_document
---
This document defines the hutlab Metacyc, Swissprot and TrEMBL reference databases,  their current location and the jobs to built them.


# Summary of the reference databases

We have generated a few reference databases:

1. Reaction  --> [Uniref50/90,Uniref50/90, ..... , Uniref50/90] 
2. Pathway  --> [Organism, Organism, ....., Organism]
3. Reaction --> [Organism, Organism, ....., Organism]

# Location of reference databases

  /n/huttenhower_lab_nobackup/downloads/metacyc/19.1_metacyc_swissprot_trembl_reference_files
 
In order to generate these reference databases, we use data both from MetCyc and from UniprotKB.
Once the data from MetaCyc and UniprotKB is downloaded,  we use the following programs to generate the reference databases:

1. Reaction_to_Uniref5090.py
2. Map_Pathway_Or_Reaction_To_Organism_from_Extract.py
 
# Download of the databses 

## UniprotKB

The current location of Swissprot and TrEMBL is http://www.uniprot.org/downloads  

### Swissprot
ftp://ftp.uniprot.org/pub/databases/uniprot/current_release/knowledgebase/complete/uniprot_sprot.dat.gz

### TrEMBL
ftp://ftp.uniprot.org/pub/databases/uniprot/current_release/knowledgebase/complete/uniprot_trembl.dat.gz

## Names, Sizes and locations of the files:

### Swissprot
2.9 Gb - Currently located at - /n/huttenhower_lab/data/uniprot/2015-06

### TrEMBL
 uniprot_trembl.dat - 132 Gb - Currently located at - /n/hutlab11_nobackup/users/gweingart/uniprotkb/uniprot_trembl


### Swissprot and TrEMBL
swissprot_trembl.dat - 141 Gb - Currently located at - /n/hutlab11_nobackup/users/gweingart/uniprotkb//swissprot_trembl
 
## Notes about the TrEMBL file

The Swissprot file can be used alone - the TrEMBL file is used **in conjunction** with the Swissprot file, so we concatente the TrEMBL file to the Swissprot file when we want to use TrEMBL data using a command as follows:

cat /n/huttenhower_lab/data/uniprot/2015-06/uniprot_sprot.dat /n/hutlab11_nobackup/users/gweingart/uniprotkb/uniprot_trembl/uniprot_trembl.dat > /n/hutlab11_nobackup/users/gweingart/uniprotkb/swissprot_trembl/swissprot_trembl.dat


## MetaCyc  files

One must get a license to download the MetaCyc files.  The license is free.
Please see:  http://metacyc.org/download.shtml


The MetaCyc files come in three levels of granularity.
For reference please see: http://metacyc.org/intro.shtml,  but in essence:

* Tier 1 PGDBs received intensive manual efforts, and are updated frequently 
* Tier 2 PGDBs were computationally generated by the PathoLogic program, and have received moderate manual updating
* Tier 3 PGDBs were computationally generated by PathoLogic, and have received no manual updates
 
 
## Downloading of the files 
### Tier 1 and 2

nohup wget --user **USERID You Received at registration**  --password **Password you received**  http://brg.ai.sri.com/ecocyc/dist/flatfiles-52983746/tier1-tier2-flatfiles.zip

## Names, Sizes and locations of the files 

### Tier 1 and 2 at release 18.1  (Note: We currently use release 19.1 - see below)
/n/huttenhower_lab_nobackup/downloads/metacyc/18.1/data

### Tier 1 and 2 at release 19.1
 
/n/huttenhower_lab_nobackup/downloads/metacyc/19.1/data 

That directory contains 36 files, 22 of which are *.dat  files and we use are:

**pathways.dat** and **reactions.dat**
 
### Tier 1, 2 and 3  at release 19.1
 
wget --user **USERID You Received at registration** --password **Password you received**  http://brg.ai.sri.com/ecocyc/dist/flatfiles-52983746/biocyc-flatfiles.zip 

Please note that this dataset of files is **huge** (502 Gb)

## Names, Sizes and locations of the files:

/n/hutlab11_nobackup/users/gweingart/biocyc

# Reference Databases

1. Mapping Reactions to Uniref 50 and 90 using Swissprot only
   + Location of the file
   
        /n/huttenhower_lab_nobackup/downloads/metacyc/19.1_metacyc_swissprot_trembl_reference_files
   
   + Job required to generate the file:
    ```
    python /n/home09/george.weingart/humann2/humann2/maintenance/Reaction_to_Uniref5090.py 
    --i_reactions /n/huttenhower_lab_nobackup/downloads/metacyc/19.1/data/reactions.dat 
    --i_sprot /n/huttenhower_lab/data/uniprot/2015-06/uniprot_sprot.dat 
    --uniref50gz /n/huttenhower_lab/data/idmapping/map_uniprot_UniRef50.dat.gz 
    --uniref90gz /n/huttenhower_lab/data/idmapping/map_uniprot_UniRef90.dat.gz 
    --o mapping_reactions_to_uniref5090_swissprot_only
    ```
2. Mapping Reactions to Uniref 50 and 90 using Swissprot **and TrEMBL**
   + Location of the file:
   
     /n/huttenhower_lab_nobackup/downloads/metacyc/19.1_metacyc_swissprot_trembl_reference_files
 
   + Job required to generate the file:
    ```
    python /n/home09/george.weingart/humann2/humann2/maintenance/Reaction_to_Uniref5090.py 
      --i_reactions /n/huttenhower_lab_nobackup/downloads/metacyc/19.1/data/reactions.dat 
      --i_sprot /n/hutlab11_nobackup/users/gweingart/uniprotkb/swissprot_trembl/swissprot_trembl.dat  
      --uniref50gz /n/huttenhower_lab/data/idmapping/map_uniprot_UniRef50.dat.gz
      --uniref90gz /n/huttenhower_lab/data/idmapping/map_uniprot_UniRef90.dat.gz 
       --o mapping_reactions_to_uniref5090_swissprot_and_trembl
    ```
3. Mapping Reactions to Uniref 50 **only** (Not Uniref90) using Swissprot and TrEMBL
    + Location of the file:
    
     /n/huttenhower_lab_nobackup/downloads/metacyc/19.1_metacyc_swissprot_trembl_reference_files
    
#  **Please Note **
    
    In order not to include Uniref90 references, please comment out the following 3 lines in the program Reaction_to_Uniref5090.py:
    
    (A parameter will be built to provide for this feature, but at the moment, this is how it is done)
    ```
    for U90 in lU90Sorted:
      bFlagUnirefFound = True  
      lBuiltRecord.append(U90) 
      
    ```
    
    + Job required to generate the file:
    ```
    python /n/home09/george.weingart/humann2/humann2/maintenance/Reaction_to_Uniref5090.py 
      --i_reactions /n/huttenhower_lab_nobackup/downloads/metacyc/19.1/data/reactions.dat 
      --i_sprot /n/hutlab11_nobackup/users/gweingart/uniprotkb/swissprot_trembl/swissprot_trembl.dat  
      --uniref50gz /n/huttenhower_lab/data/idmapping/map_uniprot_UniRef50.dat.gz
      --uniref90gz /n/huttenhower_lab/data/idmapping/map_uniprot_UniRef90.dat.gz 
       --o mapping_reactions_to_uniref50ONLY_swissprot_and_trembl
    ```



# Generating the Pathways --> Organisms and the Reactions --> Organisms references

## Procedure

We use the Tier 1,2,3 metacyc data
It consists of a very large directory (~5,000 subdirectories) where each sub-directory pertains to a different organism.
In each organism,  there is a reactions.dat and a pathways.dat
We use a grep command to extract,  for each organism,  the Organism name and the reactions or pathways name.
We run the process separately, one time for reactions and one time for pathways


  
# Details
                                                                                  
The program Map_Pathway_Or_Reaction_To_Organism_from_Extract.py creates extracts of the form:

  **Pathway-->[Organism,Organism]** 
  
 OR 
 
 **Reaction --> [Organism, Organism]**   
                                                                                    
Depending whether the input extract is from patwhays.dat or reactions.dat            
(See details below) -  but the important item is that the program is the SAME, and  
no need to change a parm,  just point it to the reactions or pathways extract     

#  Invoking the program:                                                              
 

  python Map_Pathway_Or_Reaction_To_Organism_from_Extract.py                             
  --i  organisms_pathways_extract \                                                                                                     
 --o mapping_patwhays_to_organisms                                                      
                                                                                      
  OR,  **for the reactions file**                                                            
                                                                                         

python Map_Pathway_Or_Reaction_To_Organism_from_Extract.py      
 --i  organisms_reactions_extract \                                               
--o mapping_reactions_to_organisms

Using the egrep extract for the reactions

#  NOTES and EXPLANATIONS                                                      
     

The program **Map_Pathway_Or_Reaction_To_Organism_from_Extract.py** runs against the entire download of the metacyc database which is 58Gb in   
its zipped version and 402Gb unzipped                                               
That directory contains 5,000 directories                                                
We look in each directory and extract from the pathways.dat member in each directory     
the organism name and the pathways associated for that organism                      
                                                                                          
Therefore, before this program is run,  one must extract these entries and that is done  
via the command (Ran in the root directory of the metacyc directories) 

  **egrep -r --include "pathways.dat" '# Species:|UNIQUE-ID'  .>pathways_output_extract **    
  
  
 The file output_extract  is going to be the input of this program                
Sample entries of that input file look as follows                                      
 ./bbro1208658cyc/pathways.dat:# Species: Bordetella bronchiseptica MO149                  
 ./bbro1208658cyc/pathways.dat:UNIQUE-ID - PWY-7411                                        
 ./bbro1208658cyc/pathways.dat:UNIQUE-ID - PWY-6118                                        
                                                                                           
#  <<<<<<<<<<<<<<   NOTE   >>>>>>>>>>>>>>>>>>>>>>>      

For the REACTIONS to Organisms file,  one must create the extract as follows        
                                                                                           
   **egrep -r --include "reactions.dat" '# Species:|UNIQUE-ID'  .>reactions_output_extract  ** 
                                                                                            
  and use the output of that command (reactions_output_extract) as input to this program   
   as follows:                                                                              
                                                                                            
 python Map_Pathway_Or_Reaction_To_Organism_from_Extract.py                                
    --i  organisms_reactions_extract \                                                                                                         
   --o mapping_reactions_to_organisms                                                                         
                                                                                           
 